package fs.client;

import chord.Fs;
import chord.NodeGrpc;
import com.google.protobuf.ByteString;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;
import io.grpc.Server;
import io.grpc.ServerBuilder;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static fs.client.ContentID.getFileChunks;

public class Client extends NodeGrpc.NodeImplBase {

    public static void main(String[] args) throws IOException, NoSuchAlgorithmException {

        String location3 = "/Users/ajinkyarajguru/Documents/CS297/Deliverable3/DecentralizedFileSystem/src/main/resources/emailText";
        String port=null;
        File file = new File(location3);
        byte[] byteArray;
        FileInputStream inputStream = new FileInputStream(file);
        byteArray = inputStream.readAllBytes();
        List<Chunk> chunks = getFileChunks(byteArray);
        ManagedChannel channel = ManagedChannelBuilder.forTarget("localhost:" + 9015).usePlaintext().build();
        NodeGrpc.NodeBlockingStub stub = NodeGrpc.newBlockingStub(channel);
        for(Chunk chunk: chunks) {
            Fs.FileData fD = Fs.FileData.newBuilder().setData(ByteString.copyFrom(chunk.getContent())).build();
            Fs.StoreFileRequest req = Fs.StoreFileRequest.newBuilder().setData(fD).setEndOFBlock(chunk.getEndOfBlock()).build();
            Fs.StoreFileReply resp = stub.storeFile(req);
            System.out.println(resp);
        }
        Fs.StoreFileRequest req = Fs.StoreFileRequest.newBuilder().setClose("close").build();
        Fs.StoreFileReply resp = stub.storeFile(req);
        channel.shutdown();
    }

}
