package fs.client;

import java.util.LinkedList;
import java.util.List;

public class Node {

    List<Node> childrenNodes;
    String hash;
    long endByte;

    boolean isLeaf;
    boolean isRoot;
    byte[] data;

    public Node(){

    }

    @Override
    public String toString() {
        return "Node{" +
                "childrenNodes=" + childrenNodes +
                ", hash='" + hash + '\'' +
                ", endByte=" + endByte +
                ", isLeaf=" + isLeaf +
                ", isRoot=" + isRoot +
                '}';
    }

    public Node(List<Node> childrenNodes, String hash, long endByte, boolean isLeaf, boolean isRoot) {
        this.childrenNodes = childrenNodes;
        this.hash = hash;
        this.endByte = endByte;
        this.isLeaf = isLeaf;
        this.isRoot = isRoot;
    }

    public Node(List<Node> childrenNodes, String hash, long endByte) {
        this.childrenNodes = childrenNodes;
        this.hash = hash;
        this.endByte = endByte;
    }

    public Node(String hash, long endByte) {
        this.hash = hash;
        this.endByte = endByte;
    }

    public Node(String hash, long endByte, boolean isLeaf, byte[] data) {
        this.hash = hash;
        this.endByte = endByte;
        this.isLeaf=isLeaf;
        this.data =data;
    }

    public boolean isLeaf() {
        return isLeaf;
    }

    public void setLeaf(boolean leaf) {
        isLeaf = leaf;
    }

    public boolean isRoot() {
        return isRoot;
    }

    public void setRoot(boolean root) {
        isRoot = root;
    }

    public List<Node> getChildrenNodes() {
        return childrenNodes;
    }

    public void setChildrenNodes(List<Node> childrenNodes) {
        this.childrenNodes = childrenNodes;
    }

    public void addChild(Node childNode){

        if(childrenNodes==null) childrenNodes = new LinkedList<>();
        childrenNodes.add(childNode);
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public long getEndByte() {
        return endByte;
    }

    public void setEndByte(long endByte) {
        this.endByte = endByte;
    }
}
