package fs.server;

import chord.Fs;
import chord.NodeGrpc;
import com.google.common.io.Files;
import com.google.protobuf.ByteString;
import fs.client.Chunk;
import fs.client.ContentID;
import fs.client.HashSHA256;
import io.grpc.Server;
import io.grpc.ServerBuilder;
import io.grpc.stub.StreamObserver;

import java.io.*;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;

public class StoreServer extends NodeGrpc.NodeImplBase {

    List<Chunk> chunks = new ArrayList<>();

    public static void main(String[] args) {
        Thread serverThread = new Thread(() -> {
            Server server = ServerBuilder.forPort(9015).addService(new StoreServer()).build();
            try {
                server.start();
            } catch (IOException e) {
                e.printStackTrace();
            }
            System.out.println("Server started");
            try {
                server.awaitTermination();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        });
        serverThread.start();


    }

    @Override
    public void storeFile(Fs.StoreFileRequest request, StreamObserver<Fs.StoreFileReply> responseObserver) {

        Fs.FileData fileData = request.getData();
        byte[] data = fileData.getData().toByteArray();
        long endOfBlock =  request.getEndOFBlock();;
        System.out.println(request.getEndOFBlock());
        Chunk chunk = new Chunk();
        chunk.setContent(data);
        chunk.setEndOfBlock(endOfBlock);
        try {
            chunk.setHash(HashSHA256.createHashFromFileContent(data));
            chunks.add(chunk);
        if(request.getClose()!=null && !request.getClose().isEmpty()){
            System.out.println("storing file");
            ContentID.reconstructFile(chunks,"filAdd");
        }
        Fs.StoreFileReply.Builder resp = Fs.StoreFileReply.newBuilder();
        resp.setRc(0);
        responseObserver.onNext(resp.build());
        responseObserver.onCompleted();
        }catch (Exception e){

        }
    }

//    @Override
//    public StreamObserver<Fs.StoreFileRequest> storeFile(StreamObserver<Fs.StoreFileReply> responseObserver) {
//        return new StreamObserver<Fs.StoreFileRequest>() {
//            String filehash;
//
//
//            @Override
//            public void onNext(Fs.StoreFileRequest value) {
//                if(value.hasCreate()){
//                    filehash = value.getCreate();
//                }
//                if(value.hasData()){
//
//                        try {
//
//                            Fs.FileData fileData = value.getData();
//                            ByteString data = fileData.getData();
//                            long offset = fileData.getOffset();
//                            RandomAccessFile writer = new RandomAccessFile("/Users/ajinkyarajguru/Documents/CS297/Deliverable3/DecentralizedFileSystem/src/main/resources/Server/"+filehash+"/"+filehash, "rw");
//                            FileChannel channel = writer.getChannel();
//                            ByteBuffer b = ByteBuffer.wrap(data.toByteArray());
//                            channel.write(b, offset);
//
//                                b.flip();
////                                Fs.FileData dataToBeSent = Fs.FileData.newBuilder().setData(ByteString.copyFrom(b)).setOffset(offset)
////                                        .build();
////                                streamOb.onNext(Fs.StoreFileRequest.newBuilder().setData(dataToBeSent).build());
//
//                        } catch (FileNotFoundException e) {
//                            e.printStackTrace();
//                            responseObserver.onError(e);
//                        } catch (IOException e) {
//                            e.printStackTrace();
//                            responseObserver.onError(e);
//
//                    }
//                }
//                if (value.hasClose()){
//
////                    streamOb.onNext(Fs.StoreFileRequest.newBuilder().setClose("fileClose").build());
////                    streamOb.onCompleted();
//                }
//            }
//
//            @Override
//            public void onError(Throwable t) {
//
//            }
//
//            @Override
//            public void onCompleted() {
//
//            }
//        };
//    }
//
//    @Override
//    public void readFile(Fs.ReadFileRequest request, StreamObserver<Fs.ReadFileReply> responseObserver) {
//        super.readFile(request, responseObserver);
//    }
//
//    @Override
//    public void storeMetaData(Fs.storeMetaDataRequest request, StreamObserver<Fs.storeMetaDataReply> responseObserver) {
//        super.storeMetaData(request, responseObserver);
//    }
}
